## libtorrent-rasterbar 1.2.14

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16.0 FATAL_ERROR) # Configurable policies: <= CMP0097

cmake_policy(SET CMP0091 NEW)
cmake_policy(SET CMP0092 NEW)

list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake/Modules)
include(LibtorrentMacros)

read_version("${CMAKE_CURRENT_SOURCE_DIR}/include/libtorrent/version.hpp" VER_MAJOR VER_MINOR VER_TINY)

project(libtorrent
	DESCRIPTION "Bittorrent library"
	VERSION ${VER_MAJOR}.${VER_MINOR}.${VER_TINY}
)
set (SOVERSION "10")

include(GNUInstallDirs)
include(GeneratePkgConfig)

set(libtorrent_include_files
	add_torrent_params.hpp
	address.hpp
	alert.hpp
	alert_manager.hpp
	alert_types.hpp
	announce_entry.hpp
	assert.hpp
	bandwidth_limit.hpp
	bandwidth_manager.hpp
	bandwidth_queue_entry.hpp
	bandwidth_socket.hpp
	bdecode.hpp
	bencode.hpp
	bitfield.hpp
	block_cache.hpp
	bloom_filter.hpp
	broadcast_socket.hpp
	bt_peer_connection.hpp
	buffer.hpp
	chained_buffer.hpp
	choker.hpp
	close_reason.hpp
	config.hpp
	copy_ptr.hpp
	crc32c.hpp
	create_torrent.hpp
	deadline_timer.hpp
	debug.hpp
	disk_buffer_holder.hpp
	disk_buffer_pool.hpp
	disk_interface.hpp
	disk_io_job.hpp
	disk_io_thread.hpp
	disk_io_thread_pool.hpp
	disk_job_pool.hpp
	disk_observer.hpp
	download_priority.hpp
	ed25519.hpp
	entry.hpp
	enum_net.hpp
	error.hpp
	error_code.hpp
	extensions.hpp
	file.hpp
	file_pool.hpp
	file_storage.hpp
	fingerprint.hpp
	flags.hpp
	fwd.hpp
	gzip.hpp
	hasher.hpp
	heterogeneous_queue.hpp
	hex.hpp
	http_connection.hpp
	http_parser.hpp
	http_seed_connection.hpp
	http_stream.hpp
	http_tracker_connection.hpp
	i2p_stream.hpp
	identify_client.hpp
	index_range.hpp
	invariant_check.hpp
	io.hpp
	io_service.hpp
	io_service_fwd.hpp
	ip_filter.hpp
	ip_voter.hpp
	lazy_entry.hpp
	link.hpp
	linked_list.hpp
	lsd.hpp
	magnet_uri.hpp
	natpmp.hpp
	netlink.hpp
	operations.hpp
	optional.hpp
	packet_buffer.hpp
	packet_pool.hpp
	parse_url.hpp
	part_file.hpp
	peer.hpp
	peer_class.hpp
	peer_class_set.hpp
	peer_class_type_filter.hpp
	peer_connection.hpp
	peer_connection_handle.hpp
	peer_connection_interface.hpp
	peer_id.hpp
	peer_info.hpp
	peer_list.hpp
	peer_request.hpp
	performance_counters.hpp
	pex_flags.hpp
	piece_block.hpp
	piece_block_progress.hpp
	piece_picker.hpp
	platform_util.hpp
	portmap.hpp
	proxy_base.hpp
	puff.hpp
	random.hpp
	read_resume_data.hpp
	receive_buffer.hpp
	request_blocks.hpp
	resolve_links.hpp
	resolver.hpp
	resolver_interface.hpp
	session.hpp
	session_handle.hpp
	session_settings.hpp
	session_stats.hpp
	session_status.hpp
	session_types.hpp
	settings_pack.hpp
	sha1.hpp
	sha1_hash.hpp
	sha512.hpp
	sliding_average.hpp
	socket.hpp
	socket_io.hpp
	socks5_stream.hpp
	span.hpp
	ssl_stream.hpp
	stack_allocator.hpp
	stat.hpp
	stat_cache.hpp
	storage.hpp
	storage_defs.hpp
	string_util.hpp
	string_view.hpp
	tailqueue.hpp
	time.hpp
	timestamp_history.hpp
	torrent.hpp
	torrent_flags.hpp
	torrent_handle.hpp
	torrent_info.hpp
	torrent_peer.hpp
	torrent_peer_allocator.hpp
	torrent_status.hpp
	tracker_manager.hpp
	udp_socket.hpp
	udp_tracker_connection.hpp
	union_endpoint.hpp
	units.hpp
	upnp.hpp
	utf8.hpp
	utp_socket_manager.hpp
	utp_stream.hpp
	vector_utils.hpp
	version.hpp
	web_connection_base.hpp
	web_peer_connection.hpp
	write_resume_data.hpp
	xml_parse.hpp
)

set(libtorrent_kademlia_include_files
	announce_flags.hpp
	dht_observer.hpp
	dht_settings.hpp
	dht_state.hpp
	dht_storage.hpp
	dht_tracker.hpp
	direct_request.hpp
	dos_blocker.hpp
	ed25519.hpp
	find_data.hpp
	get_item.hpp
	get_peers.hpp
	io.hpp
	item.hpp
	msg.hpp
	node.hpp
	node_entry.hpp
	node_id.hpp
	observer.hpp
	put_data.hpp
	refresh.hpp
	routing_table.hpp
	rpc_manager.hpp
	sample_infohashes.hpp
	traversal_algorithm.hpp
	types.hpp
)

set(libtorrent_extensions_include_files
	smart_ban.hpp
	ut_metadata.hpp
	ut_pex.hpp
)

set(libtorrent_aux_include_files
	aligned_storage.hpp
	aligned_union.hpp
	alloca.hpp
	allocating_handler.hpp
	array.hpp
	bind_to_device.hpp
	block_cache_reference.hpp
	byteswap.hpp
	cppint_import_export.hpp
	cpuid.hpp
	deferred_handler.hpp
	deprecated.hpp
	deque.hpp
	dev_random.hpp
	disable_warnings_pop.hpp
	disable_warnings_push.hpp
	disk_job_fence.hpp
	escape_string.hpp
	export.hpp
	ffs.hpp
	file_progress.hpp
	has_block.hpp
	instantiate_connection.hpp
	io.hpp
	ip_notifier.hpp
	keepalive.hpp
	listen_socket_handle.hpp
	lsd.hpp
	merkle.hpp
	noexcept_movable.hpp
	numeric_cast.hpp
	openssl.hpp
	path.hpp
	pool.hpp
	portmap.hpp
	proxy_settings.hpp
	range.hpp
	route.h
	scope_end.hpp
	session_call.hpp
	session_impl.hpp
	session_interface.hpp
	session_settings.hpp
	session_udp_sockets.hpp
	set_socket_buffer.hpp
	socket_type.hpp
	storage_piece_set.hpp
	storage_utils.hpp
	string_ptr.hpp
	suggest_piece.hpp
	throw.hpp
	time.hpp
	torrent_impl.hpp
	unique_ptr.hpp
	vector.hpp
	win_crypto_provider.hpp
	win_util.hpp
)

set(sources
	add_torrent_params.cpp
	alert.cpp
	alert_manager.cpp
	announce_entry.cpp
	assert.cpp
	bandwidth_limit.cpp
	bandwidth_manager.cpp
	bandwidth_queue_entry.cpp
	bdecode.cpp
	bitfield.cpp
	block_cache.cpp
	bloom_filter.cpp
	broadcast_socket.cpp
	bt_peer_connection.cpp
	chained_buffer.cpp
	choker.cpp
	close_reason.cpp
	cpuid.cpp
	crc32c.cpp
	create_torrent.cpp
	disk_buffer_holder.cpp
	disk_buffer_pool.cpp
	disk_io_job.cpp
	disk_io_thread.cpp
	disk_io_thread_pool.cpp
	disk_job_fence.cpp
	disk_job_pool.cpp
	entry.cpp
	enum_net.cpp
	error_code.cpp
	escape_string.cpp
	ffs.cpp
	file.cpp
	file_pool.cpp
	file_progress.cpp
	file_storage.cpp
	fingerprint.cpp
	generate_peer_id.cpp
	gzip.cpp
	hasher.cpp
	hex.cpp
	http_connection.cpp
	http_parser.cpp
	http_seed_connection.cpp
	http_stream.cpp
	http_tracker_connection.cpp
	i2p_stream.cpp
	identify_client.cpp
	instantiate_connection.cpp
	ip_filter.cpp
	ip_notifier.cpp
	ip_voter.cpp
	lazy_bdecode.cpp
	listen_socket_handle.cpp
	lsd.cpp
	magnet_uri.cpp
	merkle.cpp
	natpmp.cpp
	openssl.cpp
	packet_buffer.cpp
	parse_url.cpp
	part_file.cpp
	path.cpp
	peer_class.cpp
	peer_class_set.cpp
	peer_connection.cpp
	peer_connection_handle.cpp
	peer_info.cpp
	peer_list.cpp
	performance_counters.cpp
	piece_picker.cpp
	platform_util.cpp
	proxy_base.cpp
	proxy_settings.cpp
	puff.cpp
	random.cpp
	read_resume_data.cpp
	receive_buffer.cpp
	request_blocks.cpp
	resolve_links.cpp
	resolver.cpp
	session.cpp
	session_call.cpp
	session_handle.cpp
	session_impl.cpp
	session_settings.cpp
	session_stats.cpp
	settings_pack.cpp
	sha1.cpp
	sha1_hash.cpp
	socket_io.cpp
	socket_type.cpp
	socks5_stream.cpp
	stack_allocator.cpp
	stat.cpp
	stat_cache.cpp
	storage.cpp
	storage_piece_set.cpp
	storage_utils.cpp
	string_util.cpp
	time.cpp
	timestamp_history.cpp
	torrent.cpp
	torrent_handle.cpp
	torrent_info.cpp
	torrent_peer.cpp
	torrent_peer_allocator.cpp
	torrent_status.cpp
	tracker_manager.cpp
	udp_socket.cpp
	udp_tracker_connection.cpp
	upnp.cpp
	utf8.cpp
	utp_socket_manager.cpp
	utp_stream.cpp
	version.cpp
	web_connection_base.cpp
	web_peer_connection.cpp
	write_resume_data.cpp
	xml_parse.cpp

# -- extensions --
	smart_ban.cpp
	ut_pex.cpp
	ut_metadata.cpp
)

# -- kademlia --
set(kademlia_sources
	dht_settings.cpp
	dht_state.cpp
	dht_storage.cpp
	dht_tracker.cpp
	dos_blocker.cpp
	ed25519.cpp
	find_data.cpp
	get_item.cpp
	get_peers.cpp
	item.cpp
	msg.cpp
	node.cpp
	node_entry.cpp
	node_id.cpp
	put_data.cpp
	refresh.cpp
	routing_table.cpp
	rpc_manager.cpp
	sample_infohashes.cpp
	traversal_algorithm.cpp
)

# -- ed25519 --
set(ed25519_sources
	add_scalar.cpp
	fe.cpp
	ge.cpp
	key_exchange.cpp
	keypair.cpp
	sc.cpp
	sign.cpp
	verify.cpp
)

list(TRANSFORM sources PREPEND "src/")
list(TRANSFORM kademlia_sources PREPEND "src/kademlia/")
list(TRANSFORM ed25519_sources PREPEND "ed25519/src/")
list(TRANSFORM libtorrent_include_files PREPEND "include/libtorrent/")
list(TRANSFORM libtorrent_extensions_include_files PREPEND "include/libtorrent/extensions/")
list(TRANSFORM libtorrent_aux_include_files PREPEND "include/libtorrent/aux_/")
list(TRANSFORM libtorrent_kademlia_include_files PREPEND "include/libtorrent/kademlia/")

# these options control target creation and thus have to be declared before the add_library() call
feature_option(BUILD_SHARED_LIBS "build libtorrent as a shared library" ON)
feature_option(static_runtime "build libtorrent with static runtime" OFF)

find_public_dependency(Threads REQUIRED)

if(CMAKE_CXX_COMPILER_ID MATCHES Clang)
	add_compile_options(
		-Weverything
		-Wno-c++98-compat-pedantic
		-Wno-documentation
		-Wno-exit-time-destructors
		-Wno-global-constructors
		-Wno-padded
		-Wno-weak-vtables
	)
elseif(CMAKE_CXX_COMPILER_ID MATCHES GNU)
	add_compile_options(
		-Wall
		-Wc++11-compat
		-Wextra
		-Wno-format-zero-length
		-Wparentheses
		-Wpedantic
		-Wvla
		-ftemplate-depth=512
	)
elseif(MSVC)
	add_compile_options(
		# https://devblogs.microsoft.com/cppblog/msvc-now-correctly-reports-__cplusplus/
		/Zc:__cplusplus
		/W4
		# C4251: 'identifier' : class 'type' needs to have dll-interface to be
		#        used by clients of class 'type2'
		/wd4251
		# C4268: 'identifier' : 'const' static/global data initialized
		#        with compiler generated default constructor fills the object with zeros
		/wd4268
		# C4275: non DLL-interface classkey 'identifier' used as base for
		#        DLL-interface classkey 'identifier'
		/wd4275
		# C4373: virtual function overrides, previous versions of the compiler
		#        did not override when parameters only differed by const/volatile qualifiers
		/wd4373
		# C4503: 'identifier': decorated name length exceeded, name was truncated
		/wd4503
	)
endif()

if(static_runtime)
	if (MSVC)
		set(CMAKE_MSVC_RUNTIME_LIBRARY "MultiThreaded$<$<CONFIG:Debug>:Debug>")
	else()
		include(ucm_flags)
		ucm_set_runtime(STATIC)
	endif()
	set(Boost_USE_MULTITHREADED ON)
	set(Boost_USE_STATIC_RUNTIME ON)
	set(OPENSSL_MSVC_STATIC_RT ON)
endif()

if (NOT BUILD_SHARED_LIBS)
	set(Boost_USE_STATIC_LIBS ON)
	set(OPENSSL_USE_STATIC_LIBS ON)
endif()

add_library(torrent-rasterbar
	${sources}
	${libtorrent_include_files}
	${libtorrent_extensions_include_files}
	${libtorrent_aux_include_files}
)

# C++ 11 support is required
target_compile_features(torrent-rasterbar
	PUBLIC
		cxx_std_11
		cxx_alias_templates
		cxx_alignas
		cxx_alignof
		cxx_attributes
		cxx_auto_type
		cxx_constexpr
		cxx_decltype
		cxx_default_function_template_args
		cxx_defaulted_functions
		cxx_defaulted_move_initializers
		cxx_delegating_constructors
		cxx_deleted_functions
		cxx_enum_forward_declarations
		cxx_explicit_conversions
		cxx_extended_friend_declarations
		cxx_extern_templates
		cxx_final
		cxx_generalized_initializers
		cxx_inheriting_constructors
		cxx_inline_namespaces
		cxx_lambdas
		cxx_local_type_template_args
		cxx_noexcept
		cxx_nonstatic_member_init
		cxx_nullptr
		cxx_override
		cxx_range_for
		cxx_raw_string_literals
		cxx_reference_qualified_functions
		cxx_right_angle_brackets
		cxx_rvalue_references
		cxx_sizeof_member
		cxx_static_assert
		cxx_strong_enums
		cxx_trailing_return_types
		cxx_unrestricted_unions
		cxx_user_literals
		cxx_variadic_templates
)

if (BUILD_SHARED_LIBS)
	target_compile_definitions(torrent-rasterbar
		PRIVATE TORRENT_BUILDING_SHARED
		INTERFACE TORRENT_LINKING_SHARED
	)
endif()

set_target_properties(torrent-rasterbar
	PROPERTIES
		CXX_VISIBILITY_PRESET "hidden"
		VISIBILITY_INLINES_HIDDEN "true"
		VERSION ${PROJECT_VERSION}
		SOVERSION ${SOVERSION}
)

target_include_directories(torrent-rasterbar PUBLIC
	$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
	$<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
)

target_compile_definitions(torrent-rasterbar
	PUBLIC
		$<$<CONFIG:Debug>:TORRENT_USE_ASSERTS>
		BOOST_ASIO_ENABLE_CANCELIO
	PRIVATE
		TORRENT_BUILDING_LIBRARY
		_FILE_OFFSET_BITS=64
		BOOST_EXCEPTION_DISABLE
		BOOST_ASIO_HAS_STD_CHRONO
)

target_link_libraries(torrent-rasterbar
	PUBLIC
		Threads::Threads
)

# Unconditional platform-specific settings
if (WIN32)
	target_link_libraries(torrent-rasterbar
		PRIVATE
			wsock32 ws2_32 iphlpapi
			debug dbghelp crypt32
	)

=== debian/changelog ===
libtorrent-rasterbar (1.2.14-1~mx21+1) mx; urgency=medium

  * Rebuild for MX Linux.

 -- Steven Pusser <stevep@mxlinux.org>  Thu, 18 Nov 2021 13:52:17 -0800

libtorrent-rasterbar (1.2.14-1) unstable; urgency=medium

  [ Debian Janitor ]
  * Apply multi-arch hints.
    + libtorrent-rasterbar-dbg, libtorrent-rasterbar-dev,
      libtorrent-rasterbar10: Add Multi-Arch: same.
    + libtorrent-rasterbar-doc: Add Multi-Arch: foreign.

  [ Andrew Starr-Bochicchio ]
  * New upstream release.
  * Drop debian/patches/0001-python-move-storage.patch:
   - Applied upstream.
  * Stop building python3-libtorrent-dbg (Closes: #994306).
  * debian/control: Add build depends on python3-setuptools and
    libboost-tools-dev.

 -- Andrew Starr-Bochicchio <asb@debian.org>  Sat, 25 Sep 2021 11:40:11 -0400

=== debian/control ===
Source: libtorrent-rasterbar
Section: libs
Priority: optional
Maintainer: Steven Pusser <stevep@mxlinux.org>
XSBC-Original-Maintainer: Cristian Greco <cristian@debian.org>
Uploaders: Andrew Starr-Bochicchio <asb@debian.org>
Build-Depends: debhelper (>= 11),
               dh-python,
               libboost-chrono-dev,
               libboost-python-dev,
               libboost-random-dev,
               libboost-system-dev,
               libboost-tools-dev,
               libssl-dev,
               pkg-config,
               python3-all-dbg,
               python3-all-dev,
               python3-docutils,
               python3-setuptools
Standards-Version: 4.5.0
Vcs-Git: https://salsa.debian.org/debian/libtorrent-rasterbar.git
Vcs-Browser: https://salsa.debian.org/debian/libtorrent-rasterbar/
Homepage: https://libtorrent.org/

Package: libtorrent-rasterbar10
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: libtorrent-rasterbar-dbg
Multi-Arch: same
Description: C++ bittorrent library by Rasterbar Software
 Bittorrent library by Rasterbar Software (Arvid Norberg).
 libtorrent-rasterbar is a C++ library that aims to be a good alternative to
 all the other bittorrent implementations around.
 .
 The main goals of libtorrent-rasterbar are:
  * to be cpu efficient
  * to be memory efficient
  * to be very easy to use
 .
 This package contains libtorrent-rasterbar run time shared library.

Package: libtorrent-rasterbar-dev
Section: libdevel
Architecture: any
Depends: libboost-system-dev,
         libssl-dev,
         libtorrent-rasterbar10 (= ${binary:Version}),
         pkg-config,
         ${misc:Depends}
Suggests: libtorrent-rasterbar-doc
Multi-Arch: same
Description: Development files for libtorrent-rasterbar
 Bittorrent library by Rasterbar Software (Arvid Norberg).
 libtorrent-rasterbar is a C++ library that aims to be a good alternative to
 all the other bittorrent implementations around.
 .
 The main goals of libtorrent-rasterbar are:
  * to be cpu efficient
  * to be memory efficient
  * to be very easy to use
 .
 This package contains header files and static version of the library.

Package: libtorrent-rasterbar-dbg
Section: debug
Architecture: any
Depends: libtorrent-rasterbar10 (= ${binary:Version}), ${misc:Depends}
Multi-Arch: same
Description: Debug symbols for libtorrent-rasterbar
 Bittorrent library by Rasterbar Software (Arvid Norberg).
 libtorrent-rasterbar is a C++ library that aims to be a good alternative to
 all the other bittorrent implementations around.
 .
 The main goals of libtorrent-rasterbar are:
  * to be cpu efficient
  * to be memory efficient
  * to be very easy to use
 .
 This package contains debugging symbols.

Package: libtorrent-rasterbar-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Multi-Arch: foreign
Description: Documentation for libtorrent-rasterbar
 Bittorrent library by Rasterbar Software (Arvid Norberg).
 libtorrent-rasterbar is a C++ library that aims to be a good alternative to
 all the other bittorrent implementations around.
 .
 The main goals of libtorrent-rasterbar are:
  * to be cpu efficient
  * to be memory efficient
  * to be very easy to use
 .
 This package contains documentation and example files.

Package: python3-libtorrent
Section: python
Architecture: any
Depends: libtorrent-rasterbar10 (= ${binary:Version}),
         ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Description: Python bindings for libtorrent-rasterbar (Python 3)
 Bittorrent library by Rasterbar Software (Arvid Norberg).
 libtorrent-rasterbar is a C++ library that aims to be a good alternative to
 all the other bittorrent implementations around.
 .
 The main goals of libtorrent-rasterbar are:
  * to be cpu efficient
  * to be memory efficient
  * to be very easy to use
 .
 This package contains Python 3 bindings for the libtorrent-rasterbar library.

=== debian/rules ===
#!/usr/bin/make -f

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

export DEB_LDFLAGS_MAINT_APPEND  = -Wl,--as-needed
export DEB_CXXFLAGS_MAINT_APPEND  = -std=c++14

ifneq (,$(filter $(DEB_HOST_ARCH), armel mipsel m68k powerpc riscv64 sh4))
  export DEB_LDFLAGS_MAINT_APPEND += -Wl,--no-as-needed -latomic -Wl,--as-needed
endif

PYTHON3=$(shell py3versions -vr)
ALLPY=$(PYTHON3)

CONFIGURE_ARGS = --with-libiconv --with-boost-libdir=/usr/lib/$(DEB_HOST_MULTIARCH)

%:
	dh $@ --with python3

override_dh_auto_configure-nopy:
	dh_auto_configure --builddirectory build -- $(CONFIGURE_ARGS)

override_dh_auto_configure-%:
	CPPFLAGS="$(CPPFLAGS) $(shell python$*-config --includes)" \
	PYTHON_LDFLAGS="$(shell python$*-config --libs)" \
	dh_auto_configure --builddirectory build-py$* -- \
		PYTHON=/usr/bin/python$* \
		PYTHON_INSTALL_PARAMS="--root=$(CURDIR)/debian/tmp \
		--install-layout=deb" \
		--enable-python-binding \
		--with-boost-python=boost_python$(subst .,,$(subst -dbg,,$*)) \
		$(CONFIGURE_ARGS)
	mv build-py$*/bindings/python build/bindings/python$*
	cp -r bindings/python/* build/bindings/python$*
	sed s/-std=c++11//g < build/bindings/python$*/compile_cmd > build/bindings/python$*/compile_cmd.new && \
		mv -f build/bindings/python$*/compile_cmd.new build/bindings/python$*/compile_cmd

override_dh_auto_configure: override_dh_auto_configure-nopy $(ALLPY:%=override_dh_auto_configure-%)


override_dh_auto_build-nopy:
	dh_auto_build --builddirectory build
	$(MAKE) -C docs/ -f makefile

override_dh_auto_build-%:
	dh_auto_build --builddirectory build/bindings/python$*

override_dh_auto_build: override_dh_auto_build-nopy $(ALLPY:%=override_dh_auto_build-%)


override_dh_auto_install-nopy:
	dh_auto_install --builddirectory build

override_dh_auto_install-%:
	dh_auto_install --builddirectory build/bindings/python$*

override_dh_auto_install: override_dh_auto_install-nopy $(ALLPY:%=override_dh_auto_install-%)

override_dh_auto_clean:
	rm -rf build build-py*
	dh_auto_clean --buildsystem=pybuild

override_dh_compress:
	dh_compress -Xcpp

override_dh_strip:
	dh_strip --dbg-package=libtorrent-rasterbar-dbg --no-automatic-dbgsym

override_dh_makeshlibs:
	dh_makeshlibs -V

override_dh_python3:
	find debian/python3-libtorrent -name '*.cpython-*d*-$(DEB_HOST_MULTIARCH).so' | xargs -r rm -f
	dh_python3

## libtorrent-rasterbar 1.2.16~daily10769%2Be0dd73971-202206291010~ubuntu18.04.1%2B9.0trisquel1

=== CMakeLists.txt ===
--- 
+++ 
@@ -256,6 +256,7 @@
 	session_settings.hpp
 	session_udp_sockets.hpp
 	set_socket_buffer.hpp
+	set_traffic_class.hpp
 	socket_type.hpp
 	storage_piece_set.hpp
 	storage_utils.hpp
@@ -446,6 +447,7 @@
 feature_option(BUILD_SHARED_LIBS "build libtorrent as a shared library" ON)
 feature_option(static_runtime "build libtorrent with static runtime" OFF)
 
+set(THREADS_PREFER_PTHREAD_FLAG ON)
 find_public_dependency(Threads REQUIRED)
 
 if(CMAKE_CXX_COMPILER_ID MATCHES Clang)
@@ -461,18 +463,14 @@
 elseif(CMAKE_CXX_COMPILER_ID MATCHES GNU)
 	add_compile_options(
 		-Wall
-		-Wc++11-compat
 		-Wextra
-		-Wno-format-zero-length
-		-Wparentheses
 		-Wpedantic
 		-Wvla
+		-Wno-format-zero-length
 		-ftemplate-depth=512
 	)
 elseif(MSVC)
 	add_compile_options(
-		# https://devblogs.microsoft.com/cppblog/msvc-now-correctly-reports-__cplusplus/
-		/Zc:__cplusplus
 		/W4
 		# C4251: 'identifier' : class 'type' needs to have dll-interface to be
 		#        used by clients of class 'type2'
@@ -603,3 +601,6 @@
 			debug dbghelp crypt32
 	)
 
+	add_definitions(-D_WIN32_WINNT=0x0600) # target Windows Vista or later
+
+	target_compile_definitions(torrent-rasterbar

=== test/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16.0 FATAL_ERROR) # Configurable policies: <= CMP0097

# Our tests contain printf formating checks therefore we disable GCC format string errors:
if (CMAKE_CXX_COMPILER_ID MATCHES "GNU|Clang")
	check_cxx_compiler_flag("-Wno-error=format-truncation" _WNO_ERROR_FORMAT_TRUNCATION)
	if (_WNO_ERROR_FORMAT_TRUNCATION)
		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-error=format-truncation")
	endif()
endif()

file(GLOB tests "${CMAKE_CURRENT_SOURCE_DIR}/test_*.cpp")
list(REMOVE_ITEM tests "${CMAKE_CURRENT_SOURCE_DIR}/test_natpmp.cpp") # doesn't build at time of writing
list(REMOVE_ITEM tests "${CMAKE_CURRENT_SOURCE_DIR}/test_utils.cpp") # helper file, not a test

add_library(test_common STATIC
	dht_server.cpp
	main.cpp
	make_torrent.cpp
	peer_server.cpp
	settings.cpp
	setup_transfer.cpp
	swarm_suite.cpp
	test.cpp
	test_utils.cpp
	udp_tracker.cpp
	web_seed_suite.cpp
)
target_link_libraries(test_common PUBLIC torrent-rasterbar)
if (MSVC)
	target_compile_options(test_common PUBLIC
		/wd4127 # C4127: conditional expression is constant
		/wd4309 # C4309: 'conversion' : truncation of constant value
		/wd4310 # C4310: cast truncates constant value
	)
endif()

foreach(TARGET_SRC ${tests})
	get_filename_component(TARGET ${TARGET_SRC} NAME_WE)
	add_executable(${TARGET} ${TARGET_SRC})
	target_link_libraries(${TARGET} test_common)
	add_test(${TARGET} ${TARGET})
endforeach()

file(GLOB GZIP_ASSETS "${CMAKE_CURRENT_SOURCE_DIR}/*.gz")
file(COPY ${GZIP_ASSETS} DESTINATION "${CMAKE_CURRENT_BINARY_DIR}")

file(GLOB PYTHON_ASSETS "${CMAKE_CURRENT_SOURCE_DIR}/*.py")
file(COPY ${PYTHON_ASSETS} DESTINATION "${CMAKE_CURRENT_BINARY_DIR}")

file(GLOB XML_ASSETS "${CMAKE_CURRENT_SOURCE_DIR}/*.xml")
file(COPY ${XML_ASSETS} DESTINATION "${CMAKE_CURRENT_BINARY_DIR}")

file(COPY "mutable_test_torrents" DESTINATION "${CMAKE_CURRENT_BINARY_DIR}")
file(COPY "ssl" DESTINATION "${CMAKE_CURRENT_BINARY_DIR}")
file(COPY "test_torrents" DESTINATION "${CMAKE_CURRENT_BINARY_DIR}")
file(COPY "utf8_test.txt" DESTINATION "${CMAKE_CURRENT_BINARY_DIR}")

=== bindings/python/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.17.0 FATAL_ERROR) # Configurable policies: <= CMP0102

# To build python bindings we need a python executable and boost python module. Unfortunately,
# their names might not be interlinked and we can not implement a general solution.
# The code below assumes default boost installation, when the module for python 3 is named 'python3'.
# To customize that one can provide a name for the Boost::python module via
# 'boost-python-module-name' variable when invoking cmake.
# E.g. on Gentoo with python 3.6 and Boost::python library name 'libboost_python-3.6.so'
# the parameter would be -Dboost-python-module-name="python-3.6".

# The extension module and the cpython executable have to use the same C runtime library. On Windows
# Python is compiled with MSVC and we will test MSVC version to make sure that it is the same for
# the given Python version and our extension module. See https://wiki.python.org/moin/WindowsCompilers
# for details. We provide a flag to skip this test for whatever reason (pass -Dskip-python-runtime-test=True)

# Sets _ret to a list of python versions (major.minor) that use the same MSVC runtime as this build does
# assumes MSVC was detected already
# See https://en.wikipedia.org/wiki/Microsoft_Visual_C++#Internal_version_numbering
# See https://devguide.python.org/#status-of-python-branches for supported python versions
function(_get_compatible_python_versions _ret)
	if(CMAKE_CXX_COMPILER_VERSION VERSION_GREATER_EQUAL 19 AND CMAKE_CXX_COMPILER_VERSION VERSION_LESS 20)
		list(APPEND _tmp 3.6 3.7 3.8 3.9)
	endif()
	set(${_ret} ${_tmp} PARENT_SCOPE)
endfunction()


if (CMAKE_CXX_COMPILER_ID MATCHES "MSVC" AND NOT skip-python-runtime-test)
	_get_compatible_python_versions(Python_ADDITIONAL_VERSIONS)
endif()

find_package(Python3 COMPONENTS Interpreter Development REQUIRED)
if (CMAKE_CXX_COMPILER_ID MATCHES "MSVC" AND NOT skip-python-runtime-test)
	message(STATUS "Testing found python version. Requested: ${Python_ADDITIONAL_VERSIONS}, found: ${Python3_VERSION_MAJOR}.${Python3_VERSION_MINOR}")
	if (NOT "${Python3_VERSION_MAJOR}.${Python3_VERSION_MINOR}" IN_LIST Python_ADDITIONAL_VERSIONS)
		message(FATAL_ERROR "Incompatible Python and C runtime: MSVC ${CMAKE_CXX_COMPILER_VERSION} and Python ${Python3_VERSION}")
	endif()
endif()

set(boost-python-module-name "python${Python3_VERSION_MAJOR}${Python3_VERSION_MINOR}" CACHE STRING "Boost::python module name, e.g. 'python-3.6'")

find_package(Boost REQUIRED COMPONENTS ${boost-python-module-name})

Python3_add_library(python-libtorrent MODULE WITH_SOABI
	src/alert.cpp
	src/converters.cpp
	src/create_torrent.cpp
	src/datetime.cpp
	src/entry.cpp
	src/error_code.cpp
	src/fingerprint.cpp
	src/ip_filter.cpp
	src/magnet_uri.cpp
	src/module.cpp
	src/peer_info.cpp
	src/session.cpp
	src/session_settings.cpp
	src/sha1_hash.cpp
	src/string.cpp
	src/torrent_handle.cpp
	src/torrent_info.cpp
	src/torrent_status.cpp
	src/utility.cpp
	src/version.cpp
)

set_target_properties(python-libtorrent
	PROPERTIES
		OUTPUT_NAME libtorrent
)

if (MSVC)
	target_compile_options(python-libtorrent PRIVATE /bigobj)
endif()

target_link_libraries(python-libtorrent
	PRIVATE
		torrent-rasterbar
		"Boost::${boost-python-module-name}"
)

# Bindings module uses deprecated libtorrent features, thus we disable these warnings
if (CMAKE_CXX_COMPILER_ID MATCHES "GNU|Clang")
	check_cxx_compiler_flag("-Wno-deprecated-declarations" _WNO_DEPRECATED_DECLARATIONS)
	if (_WNO_DEPRECATED_DECLARATIONS)
		target_compile_options(python-libtorrent PRIVATE -Wno-deprecated-declarations)
	endif()
endif()

if (python-install-system-dir)
	set(_PYTHON3_SITE_ARCH "${Python3_SITEARCH}")
else()
	execute_process(
		COMMAND "${Python3_EXECUTABLE}" -c [=[
import distutils.sysconfig
print(distutils.sysconfig.get_python_lib(prefix='', plat_specific=True))
]=]
		OUTPUT_VARIABLE _PYTHON3_SITE_ARCH
		OUTPUT_STRIP_TRAILING_WHITESPACE
	)
endif()

message(STATUS "Python 3 site packages: ${_PYTHON3_SITE_ARCH}")
message(STATUS "Python 3 extension suffix: ${Python3_SOABI}")

install(TARGETS python-libtorrent DESTINATION "${_PYTHON3_SITE_ARCH}")

if (python-egg-info)
	set(SETUP_PY_IN "${CMAKE_CURRENT_SOURCE_DIR}/setup.py.cmake.in")
	set(SETUP_PY    "${CMAKE_CURRENT_BINARY_DIR}/setup.py")
	set(OUTPUT      "${CMAKE_CURRENT_BINARY_DIR}/timestamp")
	set(DEPS        python-libtorrent "${SETUP_PY}")

	configure_file(${SETUP_PY_IN} ${SETUP_PY} @ONLY)

	add_custom_command(OUTPUT ${OUTPUT}
		COMMAND ${Python3_EXECUTABLE} ${SETUP_PY} build -b "${CMAKE_CURRENT_SOURCE_DIR}"
		COMMAND ${Python3_EXECUTABLE} ${SETUP_PY} egg_info -b "${CMAKE_CURRENT_SOURCE_DIR}"
		COMMAND ${CMAKE_COMMAND} -E touch ${OUTPUT}
		DEPENDS ${DEPS}
	)

	add_custom_target(python_bindings ALL DEPENDS ${OUTPUT})

	install(DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/libtorrent.egg-info" DESTINATION "${_PYTHON3_SITE_ARCH}")
endif()

=== debian/changelog ===
libtorrent-rasterbar (1.2.16~daily10769+e0dd73971-202206291010~ubuntu18.04.1+9.0trisquel1) etiona-backports; urgency=medium

  * Imported to Trisquel from oficial PPA as dependency for deluge 2.x.

 -- Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>  Thu, 14 Jul 2022 12:07:24 +0000

libtorrent-rasterbar (1.2.16~daily10769+e0dd73971-202206291010~ubuntu18.04.1) bionic; urgency=low

  * Auto build.

 -- Cas <calumlind@gmail.com>  Wed, 29 Jun 2022 10:10:28 +0000

libtorrent-rasterbar (1.2.0-0~unstable~ppa0) unstable; urgency=low

  * libtorrent 1.2.0 dev

 -- Calum Lind <calumlind@gmail.com>  Tue, 22 Nov 2016 09:07:15 +0000

=== debian/control ===
Source: libtorrent-rasterbar
Section: libs
Priority: optional
Maintainer: Calum Lind <calumlind@gmail.com>
Build-Depends: debhelper (>= 9.20160114),
               dpkg-dev (>= 1.16.1~),
               dh-autoreconf,
               dh-python,
               libboost-tools-dev,
               libboost-system-dev,
               libboost-python-dev,
               libssl-dev,
               pkg-config,
               python3-all-dev,
               python3-all-dbg,
               python3-setuptools,
Standards-Version: 3.9.8
Vcs-Git: https://git.launchpad.net/~calumlind/+git/lp_lt_deb
Vcs-Browser: https://code.launchpad.net/~calumlind/+git/lp_lt_deb
Homepage: http://www.libtorrent.org
X-Python3-Version: >= 3.4

Package: libtorrent-rasterbar10
Architecture: any
Pre-Depends: dpkg (>= 1.15.6~)
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: libtorrent-rasterbar-dbg
Description: libtorrent C++ BitTorrent Library
 libtorrent is an efficient feature-complete C++ BitTorrent library.
 .
 The main goals of libtorrent are:
  * to be cpu efficient
  * to be memory efficient
  * to be very easy to use
 .
 This package contains libtorrent runtime shared library.

Package: libtorrent-rasterbar-dev
Section: libdevel
Architecture: any
Pre-Depends: dpkg (>= 1.15.6~)
Depends: ${misc:Depends},
         libtorrent-rasterbar10 (= ${binary:Version}),
         libboost-system-dev,
         libssl-dev,
         pkg-config
Description: libtorrent C++ BitTorrent Library - Development Files
 libtorrent is an efficient feature-complete C++ BitTorrent library.
 .
 The main goals of libtorrent are:
  * to be cpu efficient
  * to be memory efficient
  * to be very easy to use
 .
 This package contains header files and static version of the library.

Package: python3-libtorrent
Section: python
Architecture: any
Pre-Depends: dpkg (>= 1.15.6~)
Depends:
    ${shlibs:Depends},
    ${misc:Depends},
    ${python3:Depends},
    libtorrent-rasterbar10 (= ${binary:Version})
Description: libtorrent Python 3 Bindings
 libtorrent is an efficient feature-complete C++ BitTorrent library.
 .
 The main goals of libtorrent are:
  * to be cpu efficient
  * to be memory efficient
  * to be very easy to use
 .
 This package contains Python 3 bindings for the libtorrent library.

Package: python3-libtorrent-dbg
Section: debug
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ${python3:Depends}, python3-libtorrent (= ${binary:Version}), python3-dbg
Description: Python bindings for libtorrent-rasterbar (debug symbols) (Python 3)
 Bittorrent library by Rasterbar Software (Arvid Norberg).
 libtorrent-rasterbar is a C++ library that aims to be a good alternative to
 all the other bittorrent implementations around.
 .
 The main goals of libtorrent-rasterbar are:
  * to be cpu efficient
  * to be memory efficient
  * to be very easy to use
 .
 This package contains Python 3 bindings for the libtorrent-rasterbar library
 (debug symbols).

=== debian/rules ===
#!/usr/bin/make -f

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

export DEB_LDFLAGS_MAINT_APPEND  = -Wl,--as-needed

PYTHON3=$(shell py3versions -vr)
ALLPY=$(PYTHON3) $(PYTHON3:%=%-dbg)

# Backward compat naming for libboost_python <= 1.67
BOOST_VERSION=$(shell dpkg-query --showformat='$${Version}' --show libboost-python-dev  | cut -d '.' -f 1,2)
# non-shell 'if gt version'
ifeq "1.67" "$(word 1, $(sort 1.67 $(BOOST_VERSION)))"
BOOST_PYTHON=boost_python
else
BOOST_PYTHON=boost_python-py
endif

CONFIGURE_ARGS = --with-libiconv --with-cxx-standard=14 --with-boost-libdir=/usr/lib/$(DEB_HOST_MULTIARCH)

%:
	mkdir -p build-aux
	cp m4/config.rpath build-aux
	dh $@ --with python3,autoreconf

override_dh_auto_configure-nopy:
	dh_auto_configure --builddirectory build -- $(CONFIGURE_ARGS)

override_dh_auto_configure-%:
	CPPFLAGS="$(CPPFLAGS) $(shell python$*-config --includes)" \
	PYTHON_LDFLAGS="$(shell python$*-config --libs)" \
	dh_auto_configure --builddirectory build-py$* -- \
		PYTHON=/usr/bin/python$* \
		PYTHON_INSTALL_PARAMS="--root=$(CURDIR)/debian/tmp \
		--install-layout=deb" \
		--enable-python-binding \
		--with-boost-python=$(BOOST_PYTHON)$(subst .,,$(subst -dbg,,$*)) \
		$(CONFIGURE_ARGS)

	mv build-py$*/bindings/python build/bindings/python$*
	cp -r bindings/python/src build/bindings/python$*
	cp bindings/python/setup.py build/bindings/python$*

override_dh_auto_configure: override_dh_auto_configure-nopy $(ALLPY:%=override_dh_auto_configure-%)


override_dh_auto_build-nopy:
	dh_auto_build --builddirectory build

override_dh_auto_build-%:
	dh_auto_build --builddirectory build/bindings/python$*

override_dh_auto_build: override_dh_auto_build-nopy $(ALLPY:%=override_dh_auto_build-%)


override_dh_auto_install-nopy:
	dh_auto_install --builddirectory build

override_dh_auto_install-%:
	dh_auto_install --builddirectory build/bindings/python$*

override_dh_auto_install: override_dh_auto_install-nopy $(ALLPY:%=override_dh_auto_install-%)


override_dh_auto_clean:
	rm -rf build build-py*
	dh_auto_clean --buildsystem=pybuild

override_dh_compress:
	dh_compress -Xcpp

override_dh_makeshlibs:
	dh_makeshlibs -V

override_dh_builddeb:
	dh_builddeb -- -Z xz

=== debian/watch ===
version=4
https://github.com/arvidn/libtorrent/releases .*/@PACKAGE@-?(\d\S+)\.tar\.gz

## libtorrent-rasterbar 1.2.16~daily10769%2Be0dd73971-202206291010~ubuntu20.04.1%2B10.0trisquel1

=== debian/changelog ===
libtorrent-rasterbar (1.2.16~daily10769+e0dd73971-202206291010~ubuntu20.04.1+10.0trisquel1) nabia-backports; urgency=medium

  * Imported to Trisquel from oficial PPA as dependency for deluge 2.x.

 -- Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>  Sun, 03 Jul 2022 18:10:52 +0000

libtorrent-rasterbar (1.2.16~daily10769+e0dd73971-202206291010~ubuntu20.04.1) focal; urgency=low

  * Auto build.

 -- Cas <calumlind@gmail.com>  Wed, 29 Jun 2022 10:10:28 +0000
